
// jQuery(document).click(function(){
//     jQuery(".extra").hide();
// });

// /* Clicks within the dropdown won't make
// it past the dropdown itself */
// jQuery(".extra,#adv-toggle").click(function(e){
//     e.stopPropagation();
// });

var di_paged = 2;
var col_paged = 2;
var prof_paged = 2;

var contentPath = '/wp-content';
var httpGetVarsSearch = new URLSearchParams(window.location.search);

var megaKeyword = httpGetVarsSearch.get('keyword'); 
var megaMake = httpGetVarsSearch.get('make'); 
var megaModel = httpGetVarsSearch.get('model'); 
var megaVin = httpGetVarsSearch.get('vin'); 
var megaYearStart = httpGetVarsSearch.get('yearStart'); 
var megaYearEnd = httpGetVarsSearch.get('yearEnd'); 
var ddInited = false;

function _initDropdowns(){
    // console.log('initDropdowns');
    _getMakes();
    jQuery('#makeSelectSearch').select2({SelectOnClose: true, placeholder: 'Make', allowClear: true, width: '100%'});

    if(jQuery('#lookback')){
      jQuery('#lookback').select2({SelectOnClose: true, placeholder: 'Lookback Years', allowClear: true, width: '100%'});
    }
    
    if ( httpGetVarsSearch.get('model') ) {
      jQuery('#model').val(httpGetVarsSearch.get('model')).change();
    } else {
      if ( !httpGetVarsSearch.get('make') ) {
        // console.log('initDropdowns getAllModels');
        _getAllModels();
      }
    }

    jQuery('#modelSelectSearch').select2({SelectOnClose: true, tags: true, placeholder: 'Model', allowClear: true, width: '100%'});

    // Populate yearStart and yearEnd select elements from HTTP GET
    // variables.
    jQuery('#yearStart').select2({SelectOnClose: true, placeholder: 'Year Start', allowClear: true, width: '100%'});
    if ( httpGetVarsSearch.get('yearStart') ) {
      jQuery('#yearStart').val(httpGetVarsSearch.get('yearStart')).change();
    }
    jQuery('#yearEnd').select2({SelectOnClose: true, placeholder: 'Year End', allowClear: true, width: '100%'});
    if ( httpGetVarsSearch.get('yearEnd') ) {
      jQuery('#yearEnd').val(httpGetVarsSearch.get('yearEnd')).change();
    }
    ddInited = true;
}

function loadingDialog(cmd){
  if(cmd === 'show'){
    jQuery('.loadingDialog').css('display', 'inline-block');
  } else {
    jQuery('.loadingDialog').css('display', 'none');        
  }
}

function _getMakes(){ //populate make select via ajax              
  jQuery('#makeSelectSearch').prop("disabled", true);
  jQuery("#select2-makeSelectSearch-container").text("Loading...");
  
  // switched to reading from flat file, updated via cron
  jQuery.get( window.location.pathname == '/platinum-lookup' ? contentPath + '/scm-platinum/cache/makes_full.txt' : contentPath + '/scm-platinum/cache/makes.txt', function( data ) {
    jQuery('#makeSelectSearch').prepend(jQuery("<option />").val("").text(""));
    
    jQuery.each(data.Makes, function(i, item){  
      jQuery('#makeSelectSearch').append(jQuery("<option />").val(item).text(item));
    });
    
    jQuery('#makeSelectSearch').prop("disabled", false);
    jQuery("#makeSelectSearch option[value='loading']").remove();
    jQuery("#select2-makeSelectSearch-container").text("");   

    if(megaMake) {
        jQuery('#makeSelectSearch').val(megaMake).trigger('change');
    }
    
    if ( 'undefined' !== typeof httpGetVarsSearch.get('make') ) {
      // if make url parameter exists set value to param | bookmarkable
      // search
      jQuery( '#makeSelectSearch' ).addClass( 'disabled' );
      jQuery( '#makeSelecSearch' )
        .val( httpGetVarsSearch.get('make') )
        .trigger( 'change' )
        .attr( 'selected', 'selected' );
      jQuery( '#makeSelectSearch' ).removeClass( 'disabled' );
    }
  }, "json");                    
}

function _getAllModels() {
  //populate model select via ajax  

  jQuery('#modelSelectSearch').prop("disabled", true);
  jQuery("#select2-modelSelectSearch-container").text("Loading...");

  loadingDialog('show');   
  jQuery('#platSubmit').val('Searching...').attr("disabled", "disabled");
  jQuery('#platClear').attr("disabled", "disabled");

  jQuery.get( contentPath + '/scm-platinum/cache/allmodels.txt', function( data ) {
      jQuery('#modelSelectSearch').prepend(jQuery("<option />").val("").text(""));

      jQuery.each(data.Models, function(i, item) {
        jQuery('#modelSelectSearch').append(jQuery("<option />").val(item).text(item));
      });

      jQuery('#modelSelectSearch').prop("disabled", false);
      jQuery("#modelSelectSearch option[value='loading']").remove();
      jQuery("#select2-modelSelectSearch-container").text("");

      if(megaModel) {
        jQuery('#modelSelectSearch').val(megaModel).trigger('change');
      }
      if ( 'undefined' !== typeof httpGetVarsSearch.get('model') ) {
        // if model url parameter exists set value to param | bookmarkable
        // search
        jQuery('#modelSelectSearch')
          .val( httpGetVarsSearch.get('model') )
          .trigger('change')
          .attr('selected', 'selected');
      } else {
        jQuery('#modelSelectSearch').val("");
      }
      loadingDialog();
      jQuery('#platSubmit').val('Submit').attr("disabled", false);
      jQuery('#platClear').attr("disabled", false);
    },
    'json'
  );
}

jQuery( document ).ready(function() {
    jQuery(document).on('change', 'input[type=text],input[type=number]', function(e) {
        if(e.value != "") {
            // console.log(this);
            jQuery(this).addClass('dirty');
            // console.log(this);
        }
    });
    if(megaMake != null || megaModel != null) {
        _initDropdowns();
    }
    
    jQuery('#makeSelectSearch').on('select2:unselect', function(e) {
        setTimeout(
            () => {
                jQuery('#makeSelectSearch').select2('close');
                jQuery('#modelSelectSearch').val(null).trigger('change');//clear other
            },
            .1
        )
    });

    jQuery('#modelSelectSearch').on('select2:unselect', function(e) {
        setTimeout(
            () => {
                jQuery('#modelSelectSearch').select2('close'); //clear other
            },
            .1
        )
    });

    jQuery(document).on('select2:open', () => {
        document.querySelector('.select2-search__field').focus();
    });
    jQuery('#search_container form').change(function() {
        if(
            jQuery('#keyword').val() == "" &&
            jQuery('#makeSelectSearch').val() == "" &&
            jQuery('#modelSelectSearch').val() == "" &&
            jQuery('#s_vin').val() == ""
        ) {
            jQuery('#search_container form input[type=submit]').attr("disabled", true);
        } else {
            jQuery('#search_container form input[type=submit]').attr("disabled", false);
        }
    });
    jQuery('#adv-toggle').on('click', (event) => {
        if(!ddInited) {
            _initDropdowns();
        }
        event.preventDefault();
        jQuery('#extra').toggle();
        jQuery('#adv-toggle').toggleClass('open');
    });
    jQuery('#quickLinks a').on('click', (event) => {
        event.preventDefault();
        // console.log(event.target.getAttribute('href'));
        document.cookie = 'megasearchtab=' + event.target.getAttribute('href') ;
        jQuery('.entry-content section').slideUp(
            400,
            () => {
                jQuery(event.target.getAttribute('href')).slideDown()
            }
        );
    });

    jQuery('.entry-content').on('click', 'a.moreLink.digital',function(e, options){
        if(jQuery(e.target).attr('href') == '#'){
            e.preventDefault();
        }
        if(jQuery(e.target).attr('disabled')){
            return false;
        }
        jQuery(e.target).attr('disabled','disabled');
        
        jQuery.ajax({
            type: 'post',
            url: 'https://www.sportscarmarket.com/wp-admin/admin-ajax.php',
            data: {
                    action: 'load_digital',
                    keyword: megaKeyword,
                    make: megaMake,
                    model: megaModel,
                    vin: megaVin,
                    yearStart: megaYearStart,
                    yearEnd: megaYearEnd,
                    paged: di_paged,
                    nonce: '46467862ab'
            },
            success: function(response){
                // console.log(response);
                di_paged++;
                jQuery('#digitalIssues .results').append(response.html);
                if(response.have_posts === true) {
                    jQuery(e.target).removeAttr('disabled');
                }
            }
        })
    });

    jQuery('.entry-content').on('click', 'a.moreLink.columns',function(e, options){
        if(jQuery(e.target).attr('href') == '#'){
            e.preventDefault();
        }
        if(jQuery(e.target).attr('disabled')){
            return false;
        }

        // console.log('more columns');
        jQuery(e.target).attr('disabled','disabled');
        jQuery.ajax({
            type: 'post',
            url: 'https://www.sportscarmarket.com/wp-admin/admin-ajax.php',
            data: {
                    action: 'load_columns',
                    keyword: megaKeyword,
                    make: megaMake,
                    model: megaModel,
                    vin: megaVin,
                    yearStart: megaYearStart,
                    yearEnd: megaYearEnd,
                    paged: col_paged,
                    nonce: '8064d940f2'
            },
            success: function(response){
                // console.log(response);
                col_paged++;
                jQuery('#columns .results').append(response.html);

                if(response.have_posts === true) {
                    jQuery(e.target).removeAttr('disabled');
                }
            }
        })
    });

    jQuery('.entry-content').on('click', 'a.moreLink.profiles',function(e, options){
        if(jQuery(e.target).attr('href') == '#'){
            e.preventDefault();
        }
        if(jQuery(e.target).attr('disabled')){
            return false;
        }

        // console.log('more profiles');
        jQuery(e.target).attr('disabled','disabled');
        jQuery.ajax({
            type: 'post',
            url: 'https://www.sportscarmarket.com/wp-admin/admin-ajax.php',
            data: {
                    action: 'load_car_profiles',
                    keyword: megaKeyword,
                    make: megaMake,
                    model: megaModel,
                    vin: megaVin,
                    yearStart: megaYearStart,
                    yearEnd: megaYearEnd,
                    paged: prof_paged,
                    nonce: '9917b7a4be'
            },
            success: function(response){
                // console.log(response);
                prof_paged++;
                jQuery('#profiles .results').append(response.html);

                if(response.have_posts === true) {
                    jQuery(e.target).removeAttr('disabled');
                }
            }
        })
    });

    jQuery('#search-criteria span').on('click', function(e) {
        let tid = jQuery(e.target).attr("ID");
        let fid = tid.substring(7);
        // console.log(fid);
        jQuery('#'+fid).val('');
        // console.log(jQuery('#' + fid).val());
        // console.log('Should have cleared #' + fid);
        jQuery('#search_container form').submit();
    });

    jQuery('#search-criteria #clear-criteria').on('click', function(e) {
        console.log(jQuery('#search-criteria span'));
        jQuery('#search-criteria span').each(function(idx) {
            let tid = jQuery(this).attr("ID");
            let fid = tid.substring(7);
            console.log(fid);
            jQuery('#'+fid).val('');
        });
        jQuery('#search_container form').submit();
    });
});